/*
 * LCD interface for WG240128B
 *
 * Linux kernel version history:
 *       2009/2/4: Ported from Artila by Ace Yang . 
 *
 */



//#include <linux/config.h>
#include <linux/types.h>
#include <linux/errno.h>
#include <linux/miscdevice.h>
#include <linux/slab.h>
#include <linux/ioport.h>
#include <linux/fcntl.h>
#include <linux/netdevice.h>
#include <linux/sched.h>
#include <linux/delay.h>

#include <asm/io.h>
#include <asm/uaccess.h>
#include <asm/system.h>
#include <linux/delay.h>

#include <mach/gpio.h>
#include <mach/at91sam9_smc.h>
#include <mach/board.h>
#include <mach/at91sam9260_matrix.h>
#include <asm/mach/arch.h>

#include "lcd_WG240128B.h"
//#include "pca9555.h"

//static DEFINE_SPINLOCK(lcd_lock);

static int lcd_ioctl(struct inode *inode, struct file *file,
		     unsigned int cmd, unsigned long arg);

static unsigned int lcd_present = 1;

static int lcd_base;
static u8 lcd_read_status(void);
int Mode;

//unsigned lcd_map[80][20];

#define BusyCheck()	
#define MISC_LCD_MINOR 240

#define  Pbuffer(p,k,i) ((((p & 0xff) << (8-i)) + ((k & 0xff) >> i)) & 0xff )

#define at91_lcm_read(reg)		readb(lcd_base + (reg))//__raw_readb(lcd_base + (reg))
#define at91_lcm_write(reg, val)	writeb((val), lcd_base + (reg))//__raw_writeb((val), lcd_base + (reg))

static void lcd_write_inst(u8 cmd)
{
	//udelay(50);
	//u8 __iomem* pLCD = (void __iomem *)(at91_lcd_base[0]);
	//at91_set_gpio_output(AT91_PIN_PA21, 1); 
	//at91_set_gpio_output(AT91_PIN_PD24, 0); 
	//*(pLCD + 0x01 )= cmd;
	//at91_set_gpio_output(AT91_PIN_PD24, 1); 
	at91_lcm_write(0x1 , cmd);
	
}

static u8 lcd_read_status(void)
{
	//udelay(50);
	//u8 __iomem* pLCD = (void __iomem *)(at91_lcd_base[0]);
	 
	//return *(pLCD+0x04);
	return at91_lcm_read(0x1);
}



static void lcd_write_data(u8 data)
{
	//udelay(50);
	//u8 __iomem* pLCD = (void __iomem *)(at91_lcd_base[0]);
	//at91_set_gpio_output(AT91_PIN_PA21, 0); 
	//at91_set_gpio_output(AT91_PIN_PD24, 0); 
	//*pLCD = data;
	at91_lcm_write(0x0 , data);

}

static u8 lcd_read_data(void)
{

	return at91_lcm_read(0x0);
}


static void lcd_init_mode(u8 cmd) {
//printk("lcd_init_mode\n");
	lcd_write_data(T_BASE & 0xff);   //Data1: LowAddress
	lcd_write_data(T_BASE >> 8 );     //Data2: HighAddress
	lcd_write_inst(0x40);
//printk("lcd_init_mode 1\n");
	lcd_write_data(BYTES_PER_ROW_T);  //Data1: Colums
	lcd_write_data(0x00);              //Data2: 0
	lcd_write_inst(0x41);           //Command: 0x41 -> 01000001
	
	lcd_write_data(G_BASE & 0xff);  //Data1: LowAddress
	lcd_write_data(G_BASE >> 8);    //Data2: HighAddress
	lcd_write_inst(0x42);           //Command: 0x42 -> 01000010

	lcd_write_data(BYTES_PER_ROW_G);  //Data1: Colums
	lcd_write_data(0);              //Data2: 0
	lcd_write_inst(0x43);           //Command: 0x43 -> 01000011
//printk("lcd_init_mode 2\n");
  	//Internal OR Mode
	
	lcd_write_inst(0x80); // OR Mode    //80->10000000
	
	if(cmd == 0x94) {
		at91_set_gpio_output(AT91_PIN_PA25, 0); // 40
		at91_set_gpio_output(AT91_PIN_PA27, 1); //6*8
		//pca9555_gpio_direction_output(22,0);  //40
		//pca9555_gpio_direction_output(23,1);  //6*8
		//at91_set_gpio_output(AT91_PIN_PD27, 0); //40
		//at91_set_gpio_output(AT91_PIN_PD22, 1); //6*8
	}else {
		at91_set_gpio_output(AT91_PIN_PA25, 1); // 40
		at91_set_gpio_output(AT91_PIN_PA27, 0); //6*8
		//pca9555_gpio_direction_output(22,1);  //40
		//pca9555_gpio_direction_output(23,0);  //6*8
		//at91_set_gpio_output(AT91_PIN_PD27, 1); //40
		//at91_set_gpio_output(AT91_PIN_PD22, 0); //6*8
	}
	lcd_write_inst(0xa7); // cursor is 8 lines high		
	//set address pointer
//printk("lcd_init_mode 3\n");
	lcd_write_data(0x00);
	lcd_write_data(0x00);
	lcd_write_inst(0x21); // put cursor at (x,y)*/

  	//DisplayMode
//printk("lcd_init_mode 4\n");
	lcd_write_inst(cmd);
	
}

void graphic_index(int x , int y ,int mode){
	int addr;
	if(mode == 0)
		addr = T_BASE + (y * BYTES_PER_ROW_T) + x; // calculate place in memory
	else
		addr = G_BASE + (y * BYTES_PER_ROW_G) + x;
	//printk("addr = %x\n",addr);
	lcd_write_data(addr & 0xFF); // write calculated address
	lcd_write_data(addr >> 8); // write calculated address
	lcd_write_inst(0x24); // set cursor
}

void clean_t() {
	
	int i;
	lcd_write_inst(0x90);
	lcd_write_data(T_BASE & 0xff);
	lcd_write_data(T_BASE >> 8);
	lcd_write_inst(0x24);      // address pointer T_BASE alkuun
	graphic_index(0,0,0);
	for (i=0;i<740;i++) {
		lcd_write_data(0x00); 
		lcd_write_inst(0xc0); // kirjoita data ja inc ptr
	}
	lcd_write_inst(0x94);
	
}

void clean_g(){
	int i;
	lcd_write_inst(0x90);
	lcd_write_data(G_BASE & 0xff);
	lcd_write_data(G_BASE >> 8);
	lcd_write_inst(0x24); // address pointer G_BASE alkuun
	graphic_index(0,0,1);
	for (i=0;i<4840;i++){
		lcd_write_data(0x00); 
		lcd_write_inst(0xc0); // kirjoita data ja inc ptr
	}
	lcd_write_inst(0x98);
}

static int lcd_ioctl(struct inode *inode, struct file *file,
		     unsigned int cmd, unsigned long arg)
{
	//unsigned long address, a;
	int i , j , index1 , index2 , index3 , index4;
	unsigned char p , g ;
	struct lcd_display display;
	switch (cmd) {
		case 10:
			
			lcd_write_data(0x00);
			//udelay(20);
			lcd_write_data(0xff);
			//udelay(20);
			//udelay(10);
			lcd_write_inst(0x00);
			//udelay(20);
			//udelay(10);
			lcd_write_data(0x55);
			//udelay(10);
			lcd_write_inst(0xaa);
			break;
	case 1:
		lcd_init_mode(0x94);
		Mode = 0;
		break;
	
	case 2:
		
		lcd_init_mode(0x98);
		Mode = 1;
		break;
	case 9:
		
		lcd_init_mode(0x9c);
		Mode = 2;
		//printk("lcd_init_mode 5\n");
	break;
		
	case 3:
		
		switch (Mode) {
			case 0:
				clean_t();
				break;
			case 1:
				clean_g();
				break;
			case 2:
				clean_t();
				clean_g();
				lcd_init_mode(0x9c);
				break;
		}
		break;
	case 4: 
	{
		if (copy_from_user(&display, (struct lcd_display *) arg,
		    sizeof(struct lcd_display))) {
			printk("error\n");
			return -EFAULT;
		}
		index1 = strlen(display.buffer);
		graphic_index(display.x,display.y,0);
		for(i = 0 ; i < index1 ; i++) {
			p = display.buffer[i] - 0x20 ;
			lcd_write_data(p);
			lcd_write_inst(0xc0);
			//printk("%c ",display.buffer[i]);
		}
		//printk("\n");
		break;
	}
	
	case 5:
	{

		if (copy_from_user(&display, (struct lcd_display *) arg,
			sizeof(struct lcd_display)))
			return -EFAULT;
		index1 = display.row - 1;//行 ,y
		index4 = display.x % 8;
		index2 = display.column / 8 + ((display.column % 8)  ? 1 : 0);//列 ,x
		index3 = display.x / 8;
		
		
		
		for(i = 0 ; i <= index1 ; i++) {
			graphic_index(index3,(display.y + i),1);
			if((index4 == 0) ) {
				for( j = 0 ; j < index2 ; j++) {
					if(display.column % 8 != 0) {
						if(index2 == j+1) {
							lcd_write_inst(0xc1);
							g = lcd_read_data();
							graphic_index(index3+j,(display.y + i),1);
							p = display.buffer[(i*index2)+j];
							p |= g;
							lcd_write_data(p);
							lcd_write_inst(0xc0);
						}else {
							p = display.buffer[(i*index2)+j];
							lcd_write_data(p);
							lcd_write_inst(0xc0);
						}
					}else {
						p = display.buffer[(i*index2)+j];
						lcd_write_data(p);
						lcd_write_inst(0xc0);
					}
				}
			}else{
				for( j = 0 ; j < index2 ; j++) {
					if(j == 0) {
					lcd_write_inst(0xc1);
					g = lcd_read_data();
					
					graphic_index(index3,(display.y + i),1);
					
					p =Pbuffer(0,display.buffer[(i*index2)+j],index4) ;
					p |= g;
					lcd_write_data(p);
					lcd_write_inst(0xc0);
					
					if(index2 == 1 ) {
					lcd_write_inst(0xc1);
					g = lcd_read_data();	
					
					p =Pbuffer(display.buffer[(i*index2)+j+1],0,index4) ;
					
					p |= g;
					
					graphic_index(index3+1,(display.y + i),1);
					}else{
					p =Pbuffer(display.buffer[((i*index2)+j)]
					    ,display.buffer[(i*index2)+j+1],index4) ;
					}
					
					}
					else if((j + 1) == index2) {
					lcd_write_inst(0xc1);
					g = lcd_read_data();
					
					//if((display.column % 8 )!= 0) {	
				//	}
						
					p =Pbuffer(display.buffer[(i*index2)+j],0,index4) ;
					
					p |= g;
					
					graphic_index(index3 + j +1,(display.y + i),1);
					}
					else {
					p =Pbuffer(display.buffer[((i*index2)+j)-1]
					    ,display.buffer[(i*index2)+j],index4) ;
					}
					lcd_write_data(p);
					lcd_write_inst(0xc0);
				}
			}
		}
		
#if 0
		index1 = display.row-1 ;
		index2 = display.column / 8 ;
		if(display.flag) {
				for(i = index1 ; i >= 0 ; i--) {
					graphic_index(display.y,((index1 + display.x) - i),1);
					for( j = 0 ; j < index2 ; j++) {
						p = display.buffer[(i*index2)+j];
						lcd_write_data(p);
						lcd_write_inst(0xc0);
					}
				}
	
		}else {
			for(i = 0 ; i <= index1 ; i++) {
				graphic_index(display.y,(display.x + i),1);
				for( j = 0 ; j < index2 ; j++) {
					p = display.buffer[(i*index2)+j];
					lcd_write_data(p);
					lcd_write_inst(0xc0);
				}
			}
		}
#endif
		
		break;
	}

	case 6:
	{
		if (copy_from_user(&display, (struct lcd_display *) arg,
			sizeof(struct lcd_display)))
			return -EFAULT;

		index2 = display.row / 8;
		graphic_index(index2,display.column,1);
		lcd_write_inst(0xc1);
		p = lcd_read_data();
		//printk("%x\n",p);
		i = display.row % 8;
		switch(i) {
			case 0:g=0x80;break;
			case 1:g=0x40;break;
			case 2:g=0x20;break;
			case 3:g=0x10;break;
			case 4:g=0x08;break;
			case 5:g=0x04;break;
			case 6:g=0x02;break;
			case 7:g=0x01;break;
		}
		p |= g;
		//printk("%x\n",p);
		graphic_index(index2 ,display.column,1);
		lcd_write_data(p);
		lcd_write_inst(0xc0);
	
		break;
	}
	
	case 7:
	{
		if((unsigned long __user )arg == 0)
			//pca9555_gpio_direction_output(24,0);  //A.K
			at91_set_gpio_output(AT91_PIN_PA29, 0); //A.K
			//at91_set_gpio_output(AT91_PIN_PD23, 0);
		else
			at91_set_gpio_output(AT91_PIN_PA29, 1); //A.K
			//pca9555_gpio_direction_output(24,1);  //A.K
			//at91_set_gpio_output(AT91_PIN_PD23, 1);
		break;	
	}
	case 8:
	{
		if (copy_from_user(&display, (struct lcd_display *) arg,
			sizeof(struct lcd_display)))
			return -EFAULT;

		index2 = display.row / 8;
		graphic_index(index2,display.column,1);
		lcd_write_inst(0xc1);
		p = lcd_read_data();
		//printk("%x\n",p);
		i = display.row % 8;
		switch(i) {
			case 0:g=~0x80;break;
			case 1:g=~0x40;break;
			case 2:g=~0x20;break;
			case 3:g=~0x10;break;
			case 4:g=~0x08;break;
			case 5:g=~0x04;break;
			case 6:g=~0x02;break;
			case 7:g=~0x01;break;
		}
		p &= g;
		//printk("%x\n",p);
		graphic_index(index2 ,display.column,1);
		lcd_write_data(p);
		lcd_write_inst(0xc0);
	
		break;
		break;
	}

	default:
		
		return -EINVAL;

	}

	return 0;

}

static int lcd_open(struct inode *inode, struct file *file)
{
	if (!lcd_present)
		return -ENXIO;
	else
		return 0;
}



/*
 *	The various file operations we support.
 */

static struct file_operations lcd_fops = {
	//.read = lcd_read,
	.ioctl = lcd_ioctl,
	.open = lcd_open,
};

static struct miscdevice lcd_dev = {
	MISC_LCD_MINOR,
	"lcd",
	&lcd_fops
};



static int lcd_init(void)
{
	int ret;
	//unsigned long data;
	unsigned long csa;
#if 0
	at91_set_gpio_input(AT91_PIN_PA9,0);
	if(at91_get_gpio_value(AT91_PIN_PA9) == 1) {
		printk("Ace Test\n");
		return 0;
	}
	
	at91_set_gpio_output(AT91_PIN_PA10,0);//ace test
#endif
	pr_info("%s\n", LCD_DRIVER);
	ret = misc_register(&lcd_dev);
	if (ret) {
		printk(KERN_WARNING "Unable to register misc device.\n");
		return ret;
	}
	
	//| AT91_SMC_EXNWMODE_DISABLE
	lcd_base = (unsigned long) ioremap(AT91_CHIPSELECT_0, SZ_16K); //WR
	if(!lcd_base) {
		printk("ioremap AT91 LCD failed\n");
		return 0;
	}
	
	at91_sys_write(AT91_SMC_SETUP(0),
		#if 1
		  AT91_SMC_NWESETUP_(63)
		| AT91_SMC_NCS_WRSETUP_(63)
		| AT91_SMC_NRDSETUP_(63)
		| AT91_SMC_NCS_RDSETUP_(63)
		#else
		  AT91_SMC_NWESETUP_(0)
		| AT91_SMC_NCS_WRSETUP_(2)
		| AT91_SMC_NRDSETUP_(0)
		| AT91_SMC_NCS_RDSETUP_(2)
		#endif
	);

	/* Pulse register */
	at91_sys_write(AT91_SMC_PULSE(0),
		#if 1
		  AT91_SMC_NWEPULSE_(126)
		| AT91_SMC_NCS_WRPULSE_(126)
                | AT91_SMC_NRDPULSE_(256 )
		| AT91_SMC_NCS_RDPULSE_(126)
		#else
		  AT91_SMC_NWEPULSE_(511)
		| AT91_SMC_NCS_WRPULSE_(511)
                | AT91_SMC_NRDPULSE_(511)
		| AT91_SMC_NCS_RDPULSE_(511)
		#endif
	);

	/* Cycle register */
	at91_sys_write(AT91_SMC_CYCLE(0),
		       #if 1
		  AT91_SMC_NWECYCLE_(511)
		| AT91_SMC_NRDCYCLE_(511)
		#else
		 AT91_SMC_NWECYCLE_(7)
		| AT91_SMC_NRDCYCLE_(7)
		#endif
	);

	/* Mode register */
	at91_sys_write(AT91_SMC_MODE(0),
		   AT91_SMC_DBW_8 
		   //| AT91_SMC_EXNWMODE
		  | AT91_SMC_EXNWMODE_DISABLE
		 // | AT91_SMC_TDF_(0)
		//  | AT91_SMC_TDFMODE
	);
#if 1
	at91_set_gpio_output(AT91_PIN_PA25, 0); // 40
	at91_set_gpio_output(AT91_PIN_PA27, 1); //6*8
	at91_set_gpio_output(AT91_PIN_PA29, 1); //A.K
	at91_set_gpio_output(AT91_PIN_PA22, 0); // RESET
	mdelay(100);
	at91_set_gpio_output(AT91_PIN_PA22, 1); // RESET
#else
	pca9555_gpio_direction_output(22,0);  //40
	pca9555_gpio_direction_output(23,1);  //6*8
	pca9555_gpio_direction_output(24,1);  //A.K
	pca9555_gpio_direction_output(21,0);  // RESET
	mdelay(100);
	pca9555_gpio_direction_output(21,1);  // RESET
#endif
	//clean_g();
	return 0;		
	
}

static void __exit lcd_exit(void)
{
	iounmap(lcd_base);
	misc_deregister(&lcd_dev);
}



module_init(lcd_init);
module_exit(lcd_exit);

MODULE_AUTHOR("Ace Yang");
MODULE_LICENSE("GPL");
